<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import LeafPlot from "./_design_3_leafplot.svelte";
  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  let data = null;
  let weeks = [48, 49, 50, 51, 52];
  onMount(async () => {
    data = await json("/data/hourly_electricity_vs_gas_december.json");
  });

  function extract_data(data, location, week){
    return data.filter(datum => datum.city == location  && datum.week==week);
  }

  function get_direction(week){
    return week % 2 == 0;
  }

  function get_shift_x(week){
    if(get_direction(week) == 0)
      return -70;
    else 
      return 0;
  }

  function get_shift_y(week){
    if(get_direction(week) == 0)
      return 50;
    else 
      return 40;
  }
</script>

{#if !data}
  <p>Loading the data, please wait...</p>
{:else}
  <div>
    <svg {width} {height}>
      <line x1={innerWidth / 2} y1={innerHeight-50} x2={innerWidth / 2} y2={50} stroke="black"></line>
      <g transform="translate({margin.left}, {margin.top})">
        {#each weeks as week, i}
          <LeafPlot data={extract_data(data, "Chicago", week)} location={location} week={week} idx={i} direction={get_direction(week)}/>
          <text x={innerWidth/2 + get_shift_x(week)} y={innerHeight+get_shift_y(week) -100*(i+1)}>Week {i+1}</text>
         {/each}
         <text x={innerWidth/2 - 80} y={innerHeight - 30}>Chicago December 2014</text>
         <text x={innerWidth/2 - 140} y={innerHeight - 10}>total gas (orange) and total electricity (blue)</text>
      </g>
      
    </svg>
  </div>
{/if} 


<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
</style>
